<?php
/* -------------------------------------------------

brian suda
brian@suda.co.uk
http://www.suda.co.uk
05/05/2003
 
PHP map
ver 1.0
 
NOTES:
add names and coordinates to the friends array

USAGE:
to view the map, simply include it as any normal image
<img src="worldmap.php" title="World Map of Friends" />


------------------------------------------------- */

    /* ---------------- variables --------------- */

    $labels    = false; //(true||false)
    $font_file = "/valid/path/to/a/ttf/file/Comic.ttf";
    $map_file  = "globe.png";

    $friends = array (
      "Edinburgh, Scotland"  => array (55.923218, -3.174852),
      "New York, NY" => array (40.732151, -73.972641),
      "Chicago, IL" => array (41.83, -87.7499999999998),
      "Vancouver, BC" => array (48.55417,-123.44850),
      "Dublin, Ireland" => array (53.333, -6.25000000000002),
      "Seatle, WA" => array (47.6, -122.317),
      "Saint Louis, MO" => array (38.6328 , -90.2342),
      "London, UK" => array (51.5,-0.17),
      "Helsink, Finland" => array (60.13,25),
    );

    /* -------------- generate png --------------- */

    header("Content-type: image/png");
    $im    = imagecreatefrompng($map_file);
    $red   = imagecolorallocate($im, 255, 0, 0);
    $black = imagecolorallocate($im, 0, 0, 0);

    foreach ( $friends as $name => $location ) { 
      $lat = round((imagesy($im)/2)-((imagesy($im)/180)*$location[0]));
      $lon = round((imagesx($im)/2)+((imagesx($im)/360)*$location[1]));
      ImageArc($im, $lon, $lat, 2 , 2 , 0, 360, $red);
      if ($labels)
        ImageFtText($im, 5, 0, $lon, $lat,  $black, $font_file, $name, array("linespacing" => 0.8));
    }

    imagepng($im);
    imagedestroy($im);
?>